#ifndef READLINEH
#define READLINEH

/* Copyright (C) 2002, 2003, 2007 Thien-Thi Nguyen
 * Copyright (C) 1997, 1999, 2000 Free Software Foundation, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */
 
#include "libguile/__scm.h"

extern scm_option scm_readline_opts[];

#define SCM_HISTORY_FILE_P     scm_readline_opts[0].val
#define SCM_HISTORY_LENGTH     scm_readline_opts[1].val
#define SCM_READLINE_BOUNCE_PARENS scm_readline_opts[2].val
#define SCM_N_READLINE_OPTIONS 3

static SCM scm_readline_options (SCM setting);
static void scm_readline_init_ports (SCM inp, SCM outp);
static SCM scm_readline (SCM txt, SCM inp, SCM outp, SCM read_hook);
static SCM scm_add_history (SCM txt);
static SCM scm_read_history (SCM file);
static SCM scm_write_history (SCM file);
static SCM scm_filename_completion_function (SCM text, SCM continuep);

#ifndef HAVE_RL_CLEANUP_AFTER_SIGNAL
void rl_cleanup_after_signal ();
void rl_free_line_state ();
#endif

#endif

/* readline.h ends here */
