/* continuations.h */

#ifndef SCM_CONTINUATIONS_H
#define SCM_CONTINUATIONS_H

/* Copyright (C) 2002, 2003, 2007 Thien-Thi Nguyen
 * Copyright (C) 1995, 1996, 2000, 2002 Free Software Foundation, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */



typedef struct
{
  SCM throw_value;
  jmp_buf jmpbuf;
  SCM dynenv;
  SCM_STACKITEM *base;
  unsigned long seq;

#if 1 /* petrified DEBUG_EXTENSIONS */
  struct scm_debug_frame *dframe;
#endif
} scm_contregs;


#define SCM_CONTREGS(x)		((scm_contregs *) SCM_CELL_WORD_1 (x))
#define SCM_SET_CONTREGS(x, r)	(SCM_SET_CELL_WORD_1 ((x), (scm_bits_t) (r)))

#define SCM_JMPBUF(x)		((SCM_CONTREGS (x))->jmpbuf)
#define SCM_DYNENV(x)		((SCM_CONTREGS (x))->dynenv)
#define SCM_THROW_VALUE(x)	((SCM_CONTREGS (x))->throw_value)
#define SCM_BASE(x)		((SCM_CONTREGS (x))->base)
#define SCM_SEQ(x)		((SCM_CONTREGS (x))->seq)
#define SCM_DFRAME(x)		((SCM_CONTREGS (x))->dframe)



extern SCM scm_make_cont (SCM * answer);
extern SCM scm_call_continuation (SCM cont, SCM val);
extern SCM scm_continuation_p (SCM obj);




#if (SCM_DEBUG_DEPRECATED == 0)

#define SCM_SETJMPBUF(x, r) (SCM_SET_CONTREGS ((x), (r)))

#endif  /* SCM_DEBUG_DEPRECATED == 0 */

#endif  /* SCM_CONTINUATIONS_H */

/* continuations.h ends here */
