/* modules.h */

#ifndef SCM_MODULES_H
#define SCM_MODULES_H

/* Copyright (C) 2002, 2007 Thien-Thi Nguyen
 * Copyright (C) 1998, 2000, 2002 Free Software Foundation, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */




extern SCM scm_the_root_module (void);
extern SCM scm_selected_module (void);
extern SCM scm_select_module (SCM module);
extern SCM scm_make_module (SCM name);
extern SCM scm_ensure_user_module (SCM name);
extern SCM scm_module_lookup_closure (SCM module);
extern SCM scm_resolve_module (SCM name);
extern SCM scm_load_scheme_module (SCM name);
extern SCM scm_module_ref (SCM module, SCM name);
extern SCM scm_env_top_level (SCM env);
extern SCM scm_top_level_env (SCM thunk);
extern SCM scm_system_module_env_p (SCM env);
extern SCM scm_standard_eval_closure (SCM module);

extern void scm_register_needy_module_xxx (char *module_name,
                                           void (*init_func) (void),
                                           char **up);

extern void scm_register_module_xxx (char *module_name,
                                     void (*init_func) (void));





/* EXPERIMENTAL */

#include "libguile/gsubr.h"             /* for scm_c2x_nm_fn_t (fixme) */

struct scm_nm_pobj {
  const char              *name;
  const unsigned long int  len;
  SCM                     *p;
};

struct scm_obj_nm_zip {
  const size_t  count;
  SCM          *p;
  const char   *names[];
};

struct scm_module_initspec {
  const char                           **modnm_list;
  const struct scm_nm_pobj              *symbols;
  const struct scm_nm_pobj              *strings;
  const struct scm_nm_pobj              *keywords;
  const struct scm_obj_nm_zip           *runtime;
  const struct scm_obj_nm_zip          **upspecs;
  const scm_c2x_nm_fn_t                 *nm_fn_list;
  const unsigned short int              *packed_rov;
  void                                 (*misc) (void);
  const struct scm_obj_nm_zip           *exported;
  const struct scm_smob_descriptor      *smobs;
  void                                  *more;
};

#endif  /* SCM_MODULES_H */

/* modules.h ends here */
