/* options.h */

#ifndef SCM_OPTIONS_H
#define SCM_OPTIONS_H

/* Copyright (C) 2002, 2007 Thien-Thi Nguyen
 * Copyright (C) 1995, 1996, 2000, 2002 Free Software Foundation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * The author can be reached at djurfeldt@nada.kth.se
 * Mikael Djurfeldt, SANS/NADA KTH, 10044 STOCKHOLM, SWEDEN */





typedef struct scm_option
{
  int type;
  char *name;

  /*
    schizophrenic use: both SCM and int
   */
  unsigned long val;
  /* SCM val */
  char *doc;
} scm_option;

#define SCM_OPTION_BOOLEAN 0
#define SCM_OPTION_INTEGER 1
#define SCM_OPTION_SCM     2


extern SCM scm_options (SCM new_mode, scm_option options[], int n, const char *s);
extern void scm_init_opts (SCM (*func) (SCM), scm_option options[], int n);


#endif /* SCM_OPTIONS_H */

/* options.h ends here */
