/* script.h */

#ifndef SCM_SCRIPT_H
#define SCM_SCRIPT_H

/* Copyright (C) 2002, 2007 Thien-Thi Nguyen
 * Copyright (C) 1997, 1998, 2000, 2002 Free Software Foundation, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */


extern char *scm_find_executable (const char *name);
extern char *scm_find_impl_file (char *exec_path,
                                 const char *generic_name,
                                 const char *initname,
                                 const char *sep);
extern char **scm_get_meta_args (int argc, char **argv);
extern int scm_count_argv (char **argv);
extern void scm_shell_usage (int fatal, char *message);
extern SCM scm_compile_shell_switches (int argc, char **argv);
extern void scm_shell (int argc, char **argv);
extern char *scm_usage_name;


#endif  /* SCM_SCRIPT_H */

/* script.h ends here */
