/* weaks.h */

#ifndef SCM_WEAKS_H
#define SCM_WEAKS_H

/* Copyright (C) 2002, 2007 Thien-Thi Nguyen
 * Copyright (C) 1995, 1996, 2000, 2002 Free Software Foundation, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */






#define SCM_WVECTP(x) (SCM_NIMP (x) && (SCM_TYP7 (x) == scm_tc7_wvect))
#define SCM_IS_WHVEC(X) (SCM_UNPACK (SCM_VELTS (X)[-1]) == 1)
#define SCM_IS_WHVEC_V(X) (SCM_UNPACK (SCM_VELTS (X)[-1]) == 2)
#define SCM_IS_WHVEC_B(X) (SCM_UNPACK (SCM_VELTS (X)[-1]) == 3)
#define SCM_IS_WHVEC_ANY(X) (SCM_UNPACK (SCM_VELTS (X)[-1]) != 0)
#define SCM_WVECT_GC_CHAIN(X) (SCM_VELTS (X)[-2])

extern SCM scm_weak_vectors;



extern SCM scm_make_weak_vector (SCM k, SCM fill);
extern SCM scm_weak_vector (SCM l);
extern SCM scm_weak_vector_p (SCM x);
extern SCM scm_make_weak_key_hash_table (SCM k);
extern SCM scm_make_weak_value_hash_table (SCM k);
extern SCM scm_make_doubly_weak_hash_table (SCM k);
extern SCM scm_weak_key_hash_table_p (SCM x);
extern SCM scm_weak_value_hash_table_p (SCM x);
extern SCM scm_doubly_weak_hash_table_p (SCM x);
extern void scm_weaks_prehistory (void);


#endif  /* SCM_WEAKS_H */

/* weaks.h ends here */
